/*****************************************************************************/
//    LogicalArrayArg.C
/*****************************************************************************/

#include "LogicalArrayArg.h"

#include "BuiltinSymbols.h"

/*****************************************************************************/

char *corLogicalArrayConstructorString = "logical_array";
char *corLogicalArrayBindString = "logical_bind";

/*****************************************************************************/
corLogicalArrayArg::corLogicalArrayArg(int size1)
{
    _size = size1;
    corarray = new corVersionedBindEnv(_size);
    corTerm term0(corNilSymbol,NULL);
    for(int i=0; i < _size; i++)
        corarray->forcebind(i,term0);
}

/*****************************************************************************/
corLogicalArrayArg::corLogicalArrayArg(int size1, corVersionedBindEnv *env)
{
    _size = size1;
    corarray = env;
}

/*****************************************************************************/
void corLogicalArrayArg::print(corBindEnv *context, FILE *file) const
{
    fprintf(file, " ARRAY(");
    for(int i=0; i < _size; i++) {
        lookup(i).print(context, file);
        if (i < _size -1) fprintf(file, ",\n\t");
    }
    fprintf(file, ")");
}

/*****************************************************************************/
corArrayArg* corLogicalArrayArg::make_version()
{
    corVersionedBindEnv *new_array = (corVersionedBindEnv *)corarray->make_version();
    corLogicalArrayArg *new_arg =  new corLogicalArrayArg(_size, new_array);
    return new_arg;
}

/*****************************************************************************/

