/*****************************************************************************/
//    PipelinedExecInfo.h
/*****************************************************************************/

#ifndef _PipelinedExecInfo_H_
#define _PipelinedExecInfo_H_

#include "RuleInfo.h"
//#include "TupleIterator.h"
#include "StackMark.h"
#include "ArrayBindEnv.h"
#include "Rule.h"
//#include "QFPipelinedModuleData.h"

/*****************************************************************************/

class corTupleIterator;
class corQFPipelinedModuleData;
class corTable;

/*****************************************************************************/

class corPipelinedExecInfo {
public:
     // The following variables maintain state within a rule
     // Basically all fields used in SemiNaive::evaluate() have to
     // be available to PipelinedExecInfo::Solve()
     int index;
     int current;
     int backtrack_index;

     unsigned int direction : 1;        // direction of current rule evaluation
     unsigned int cut_crossed : 1;        // has a cut been crossed in this rule ?

     int successBacktrack;                // backtrack point on success
     int *firstFailureBacktrack;
     int *nextFailureBacktrack;

     corRuleInfo *rInfo;

     corTupleIterator **tuple_its;
     corStackMark stackmark0;
     corArrayBindEnv *env;
        // BindEnv for the rule currently under consideration

     corStackMark *stack_marks;
        //set of stack marks for the literals on rule rhs

     int *indices;
        // will point to the indices in the QFPipelinedModuleData

     corTuple **tuples;
        // set of tuples from literals on rhs of rule
         // and this tells us which rule we were at when we returned

     corClause *curRule;
        // points to the rule that is currently being examined

     corTable *F;
        // points to the Table in QFPipelinedModuleData

     int numVars;
     int numLits;

     //PipelinedExecInfo(QFPipelinedModuleData *md,Name name, int arity);
     int init();
     corPipelinedExecInfo(corQFPipelinedModuleData *md, int pred_offset);
     ~corPipelinedExecInfo();
     int Solve();
     int NextRule(corQFPipelinedModuleData *md);
};

/*****************************************************************************/

#endif _PipelinedExecInfo_H_

