/*****************************************************************************/
//    QFPipelinedModuleData.C
/*****************************************************************************/

#include "QFPipelinedModuleData.h"

#include "ParserStruct.h"

/*****************************************************************************/
corQFPipelinedModuleData::corQFPipelinedModuleData (corTable *table,
    corRuleInfoArray *rArray, corParserStruct& corparserStruct)
    : backtrackInfo(rArray, corparserStruct.CurModule.NonGroundFacts)
{
    F = table;
    ruleArray = rArray;
    multiset_annotations = corparserStruct.MultisetAnnotations;
    index_annotations = corparserStruct.make_index_annotations;
    agg_sel_annotations = NULL;
    prioritize_annotations = NULL;
    diskrel_annotations = NULL;
    
    TableSetUp = 0;            // no pipelined execs in progress
    rel_options = 0;
    predicates = new corModulePred(NULL);
}

/*****************************************************************************/
void corQFPipelinedModuleData::clean_cache()
{
    for (int i = 0; i< ruleArray->num_rules();i++) {
        for (int j = 0;j< (ruleArray->rInfoPtrs[i])->num_literals; j++) {
            indices[i][j] = -1;
        }
    }
}

/*****************************************************************************/

