/*****************************************************************************/
//    Context.h
/*****************************************************************************/

#ifndef _Context_H_
#define _Context_H_

#include "ContextNode.h"
#include "GoalNode.h"

/*****************************************************************************/
//    Codependent classes

class corContextNode;

/*****************************************************************************/

class corContext {
public:
    corContextNode *first;
    corContextNode *last;
    corContextNode *first_marked;
    corContextNode *last_marked;

    corContext();
    void add_new_goal(corGoalNode *g_node, corGoalNode *par);
    void insert_last(corContextNode *c_node);
    void insert_before(corContextNode *c_node, corContextNode *par_next_c_node);

    void delete_goal(corGoalNode *g);
    void unlink_node(corContextNode *g_c_node);

    corGoalNode *get_unmarked_goal(int &any_new_fact_in_done);
    void update_marked_info(corContextNode *c_node);

    void collapse_nodes(corGoalNode *from, corGoalNode *par, corGoalNode *to);
    void print_all(FILE *file);
    void free_all();
};

/*****************************************************************************/

#endif _Context_H_

