/*****************************************************************************/
//    RMarkArray.C
/*****************************************************************************/

#include "RMarkArray.h"

/*****************************************************************************/
/*
    Constructor for RMarkArray. All RMarks * are initially NULL.
    Even RMarks are 'old' and odd RMarks are 'new'.
    Size should be even !!
*/

corRMarkArray::corRMarkArray(int size)
{
    markList = new corRMark*[size];
    for (int i = 0; i< size; i++) {
        markList[i] = NULL;
    }
    array_size = size;
}

/*****************************************************************************/
/*
    Copies a new RMark at position i+1 to the old RMark at position i.
    Obviously, i should be even.
*/

void corRMarkArray::New_To_Old(int i)
{
    if (i < array_size - 1) {
        markList[i] = markList[i+1] ;
        markList[i+1] = NULL;
    }
}

/*****************************************************************************/
corRMarkArray::~corRMarkArray()
{
    delete [] markList ;
}

/*****************************************************************************/

