// *************************************************************************
//    Sips.h
// *************************************************************************

#ifndef _Sips_H_
#define _Sips_H_

// *************************************************************************
// Sideways instruction passing strategy representation

struct corsips {
    corBitVector adorn;
    struct corsip*    sip_list;
    struct corsips* next;
};

// *************************************************************************

struct corsip {
    corBitVector tail;           // BitVector of indexes into rhs preds[] 
    int    head;              // 0 if head, else index into rhs preds[]+1 
    corBitVector bound_vars;     // Bits that are set are used to 
                              // index into var_names[] 
    struct corsip*    next;
};

// *************************************************************************

#define numpredsinsip(s)    (s)->count()
#define firstpredinsip(s)    (s)->next(-1)
#define nextpredinsip(s,p)    (s)->next(p)

// *************************************************************************

#endif _Sips_H_
