// *************************************************************************
//	ClauseInfo.h
// *************************************************************************

#ifndef _ClauseInfo_H_
#define _ClauseInfo_H_

#include "BitVector.h"
#include "Rule.h"

/*****************************************************************************/
//	ClauseInfo is used to pass information between various subroutines.
//	It is also used to hold "global" information when using scan_vars().

struct ClauseInfo {
	corClause *rule;
	int *var_defining_pred;		// First body pred occurence where the variable
				 				// occurs, -1 if it doesn't occur in the body
	corBitVector* var_head_arg_pos; // pos in the head where var appears
	int i;		 				//	Used to communicate with scan_vars().
	char *sip_generated;
	struct corsips *cur_sips;
	corBitVector *adorn;
	corBitVector* tail;
};

/*****************************************************************************/

#endif _ClauseInfo_H_

